#
# shinGETsu - P2P anonymous BBS
#
# (c) Fuktommy <fuktommy@users.sourceforge.net>
# Released under the GNU General Public License
# $Id: CacheStat.pm,v 1.9 2004/02/22 10:36:19 fuktommy Exp $
#

package Shingetsu::CacheStat;
use Shingetsu::Config;
use Shingetsu::Util;

#
# configration
#
$datadir  = $Shingetsu::Config::datadir;
$statfile = $Shingetsu::Config::stat;

#
# get status list
#
sub list() {
	local $_;
	my %stat = ();
	if (open IN, $statfile) {
		while (<IN>) {
			chomp;
			local @_ = split /<>/;
			$stat{$_[0]} = {
					stamp	=> $_[1],
					records	=> $_[2],
				};
		}
		close IN;
		return %stat;
	} else {
		return ();
	}
}

#
# sync hash to file
#
sub sync(%) {
	my(%stat) = @_;
	local $_;
	Shingetsu::Util::lock();
	open OUT, "> $statfile" or die "$statfile: open failed. $!";
	my ($k,$v);
	while (($k,$v) = each %stat) {
		next if ((! defined $k) || ($k eq ""));
		foreach ($$v{stamp}, $$v{records}) {
			$_ = 0 unless (defined $_);
		}
		print OUT "$k<>$$v{stamp}<>$$v{records}\n";
	}
	close OUT;
	Shingetsu::Util::unlock();
}

#
# update latest status
#
sub update() {
	my @file = glob "$datadir/*.dat";
	my %stat = ();
	local $_;
	foreach (@file) {
		my %tmp = ();
		$filename  = $_;
		$filename =~ s|$datadir/||;
		$filename =~ s|\.dat$||;

		my @data = ();
		if (open IN, $_) {
			@data = <IN>;
			close IN;
		}
		if (@data) {
			local @_ = split /<>/, $data[-1];
			$tmp{stamp} = $_[0];
		} else {
			$tmp{stamp} = 0;
		}

		$tmp{records} = @data;
		$stat{$filename} =  {%tmp};
	}
	sync(%stat);
}

1;
