#
# shinGETsu - P2P anonymous BBS
#
# (c) FukTommy <fuktommy@users.sourceforge.net>
# Released under the GNU General Public License
# $Id: Extern.pm.command,v 1.1 2004/01/12 08:59:24 fuktommy Exp $
#

package Shingetsu::Extern;
use Socket;
use IPC::Open2;
use Shingetsu::Config;

#
# pipe command
#
sub command($@) {
	my($command, @input) = @_;
	local $SIG{CHLD} = "DEFAULT";
	open2 IN, OUT, "$command" or die "$command: exec faild. $!";
	binmode IN; binmode OUT;
	local $_;
	if (fork == 0) {
		close IN;
		print OUT @input;
		close OUT;
		exit;
	}
	close OUT;
	my @buf = ();
	while (<IN>) {
		push @buf, $_;
	}
	close IN;
	wait; wait;
	return @buf;
}


#
# mime base-64 encode
#
sub base64encode($) {
	my @buf = command("$Shingetsu::Config::command{uuencode} null", @_);
	$_ = shift @buf;
	if ($_ !~ /^begin-base64/) {
		die "$uuencode: wrong output.";
	}
	pop @buf;
	chomp @buf;
	return join "", @buf;
}

#
# mime base-64 decode
#
sub base64decode($) {
	my($input) = @_;
	my @input = ("begin-base64 644 -\n");

	my $l = length $input;
	for ($i=0; $i<$l; $i+=60) {
		push @input, substr($input, $i, 60) . "\n";
	}
	push @input, "====\n";
	my @buf = command($Shingetsu::Config::command{uudecode}, @input);
	return join "", @buf;
}

#
# md5 message-digest
#
sub md5digest($) {
	my @buf = command($Shingetsu::Config::command{md5sum}, @_);
	return substr $buf[0], 0, 32;
}

#
# gzip
#
sub xgzip($) {
	my @buf = command($Shingetsu::Config::command{gzip}, @_);
	return join "", @buf;
}

#
# gunzip
#
sub xgunzip(@) {
	return command($Shingetsu::Config::command{gunzip}, @_);
}

#
# wget
#
sub wget($) {
	my($uri) = @_;
	$uri =~ m|http://(.+):(\d+)/(.*)| or retrun ();
	my($host, $port, $path) = ($1, $2, "/$3");
	my $EOM = "\0END OF MESSAGE\0";
	my $timeout = $Shingetsu::Config::timeout;
	my $bufsize = $Shingetsu::Config::bufsize;
	pipe IN, OUT;
	if (fork) {
		local $_;
		my @buf = ();
		local $SIG{CHLD} = "DEFAULT";
		while (<IN>) {
			last if (/^$EOM/);
			push @buf, $_;
		}
		wait;
		chop $buf[-1];
		return @buf;
	} else {
		my($addr, $sockaddr);
		my $try = $Shingetsu::Config::retry;
		$EOM = "\n$EOM\n";
		local $SIG{ALRM} = sub { print OUT $EOM; close OUT;
					 die "$host:$port: connection timeout."; };
		START:
		alarm $timeout;
		unless ($addr = inet_aton $host) {
			if ($try-- > 0) {
				sleep 3;
				goto START;
			}
			print OUT $EOM;
			close OUT;
			die "$host: faild to resolv. $!";
		}
		$sockaddr = pack_sockaddr_in($port, $addr);
		unless (socket SOCKET, PF_INET, SOCK_STREAM, 0) {
			if ($try-- > 0) {
				sleep 3;
				goto START;
			}
			print OUT $EOM;
			close OUT;
			die "failed to open socket. $!";
		}
		unless (connect SOCKET, $sockaddr) {
			if ($try-- > 0) {
				sleep 3;
				goto START;
			}
			print OUT $EOM;
			close OUT;
			die "$host:$port: fault to connect. $!";
		}
		select SOCKET; $| = 1;
		local $, = "\r\n";
		local $_;
		alarm $timeout;
		my $ver = $Shingetsu::Config::version;
		print "GET $path HTTP/1.0",
		      "User-Agent: shinGETsu/$ver",
		      "Host: $host:$port",
		      "Accept: text/plain",
		      "Accept-Encoding: gzip",
		      "Connection: close",
		      "\r\n";
		my $buf;
		while (read SOCKET, $buf, $bufsize) {
			print OUT $buf;
			alarm $timeout;
		}
		alarm 0;
		close SOCKET;
		print OUT $EOM;
		close OUT;
		exit;
	}
}

1;
