#!/usr/bin/perl -w
#
# shinGETsu - P2P anonymous BBS
#
# (c) Fuktommy <fuktommy@users.sourceforge.net>
# Released under the GNU General Public License
# $Id: test.pl,v 1.1 2004/02/24 15:44:36 fuktommy Exp $
#

use lib qw(..);
use Socket;
use Shingetsu::Config;
use Shingetsu::Extern;
use Shingetsu::Signature;

sub result($) {
	if ($_[0]) {
		print "ok\n";
	} else {
		print "NG\n";
	}
}

$| = 1;
$SIZE = 40;

printf "%-*s", $SIZE, "checking BASE64 encode ... ";
$buf = Shingetsu::Extern::base64encode("abcdefgh");
result($buf eq "YWJjZGVmZ2g=");

printf "%-*s", $SIZE, "checking BASE64 decode ... ";
$buf = Shingetsu::Extern::base64decode("YWJjZGVmZ2g=");
result($buf eq "abcdefgh");

printf "%-*s", $SIZE, "checking MD5 message digest ... ";
$buf = Shingetsu::Extern::md5digest("abcdefgh");
result($buf eq "e8dc4081b13434b45189a720b77b6818");

printf "%-*s", $SIZE, "checking GZIP compress ... ";
$buf = Shingetsu::Extern::xgzip("abcdefgh");
$buf = unpack 'H*', $buf;
result($buf eq "1f8b08000000000000034b4c4a4e494d4bcf0000502aefae08000000");

printf "%-*s", $SIZE, "checking GZIP expand ... ";
@buf = (pack 'H*', "1f8b08000000000000034b4c4a4e494d4bcf0000502aefae08000000");
@buf = Shingetsu::Extern::xgunzip(@buf);
result($buf[0] eq "abcdefgh");

printf "%-*s", $SIZE, "checking APOLLO signature module ... ";
@buf = Shingetsu::Signature::generate("abcdefgh", "ijklmnop");
result(($buf[0] eq "HFYd4FUjxeXPcdebrhJac4s/dEDN7Yp9P/XopbwYQrqOGdonsX/pAOAFv4RMaDle5ZwSfM/rNDoJGk+pGF9nmB") && ($buf[1] eq "6YTQFxo0wKLPZaDfh++/T0GZ+2ny/tKZh1adIjlE47Fei4QwmJXIbrB8Q2Y+uOQZVFThqPTH7YVzAaX9N1aFBB"));

printf "%-*s", $SIZE, "checking HTTPD port ... ";
$port = $Shingetsu::Config::port;
if (fork == 0) {
	socket CLIENT_WAITING, PF_INET, SOCK_STREAM, 0 or die "failed to open socket. $!\n";
	setsockopt CLIENT_WAITING, SOL_SOCKET, SO_REUSEADDR, 1 or die "failed to setsockopt. $!\n";
	bind CLIENT_WAITING, pack_sockaddr_in($port, INADDR_ANY) or die "failed to bind. $!\n";
	listen CLIENT_WAITING, SOMAXCONN or die "failed to listen: $!\n";
	$paddr = accept(CLIENT, CLIENT_WAITING);
#	my ($client_port, $client_iaddr) = unpack_sockaddr_in $paddr;
#	local $client_ip = inet_ntoa $client_iaddr;
#	warn "$client_port, $client_ip\n";
	exit;
}
@buf = Shingetsu::Extern::wget("http://www.thedonkeynetwork.com:80/connection_test?port=$port");result (grep /connection was accepted/, @buf);
wait;
